/**
 * steve_tyler
 *
 * This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
 */

'use strict';

const _request = require('../Http/Client/RequestClient');
const _configuration = require('../configuration');
const _apiHelper = require('../APIHelper');
const _baseController = require('./BaseController');

class LOSPricingController {
    /**
     * Introduction: You can use this function if you would like to send BookingPal different
     * prices for various Length of Stays with the same starting date.
     * LOS Pricing will be a different method in sending rates to BookingPal and is defined as
     * pricing sent for a specific “Stay ranges”, In the LOS  method you are setting specific
     * rates based on the Length of Stay. (This is a different way to push rates to BookingPal.
     * )
     * For date periods of 1 to 30 days a specific rate need to enter check-in date and a rate
     * for every possible reservation starting at that date (i.e. 1 day, 2 days, up to 30 days,
     * 30 days is the maximum value allowed for this field) you will need to send BookingPal
     * total rate value for that period.
     * Maximum LOS number of days is 30. All other LOS values after 30 will not be saved. If you
     * do not support reservation for some specific number of dates - send value 0.00 for this
     * LOS number of days. Keep in mind that all values not sent for any specific check-in date
     * will be considered as 0, and reservation for this number of days will not be possible.
     * Field maxGuests allows you to set different rates per different number of guests. If you
     * do not have different rate values per number of guests - you can send the value for
     * maximum number of guests, and all others will have the same rate.
     * For MLT properties which supported LOS price for update number of count you can use it
     * rates and availability API.
     * It is suggested to manage availability over “rates and availability” API call, and to
     * close/open dates over this call.
     * Note: this API call can be used only if you set supportedLosRates = true on the product.
     * Otherwise using this API for specific product is not possible.
     *
     * @param {string} contentType TODO: type description here
     * @param {CreateandupdateLOSRequest} body TODO: type description here
     *
     * @callback    The callback function that returns response from the API call
     *
     * @returns {Promise}
     */
    static createandupdateLOSLengthofStayPricing(contentType, body, callback) {
        // create empty callback if absent
        const _callback = typeof callback === 'function' ? callback : () => undefined;

        // prepare query string for API call
        const _baseUri = _configuration.BASEURI;

        const _pathUrl = '/losrates';
        let _queryBuilder = `${_baseUri}${_pathUrl}`;

        // process query parameters
        _queryBuilder = _apiHelper.appendUrlWithQueryParameters(_queryBuilder, {
            jwt: _configuration.jwt,
        });

        // validate and preprocess url
        const _queryUrl = _apiHelper.cleanUrl(_queryBuilder);

        // prepare headers
        const _headers = {
            accept: 'application/json',
            'content-type': 'application/json; charset=utf-8',
            'Content-Type': contentType,
            'user-agent': 'APIMATIC 2.0',
        };

        // construct the request
        const _options = {
            queryUrl: _queryUrl,
            method: 'POST',
            headers: _headers,
            body: _apiHelper.jsonSerialize(body),
        };

        // build the response processing.
        return new Promise((_fulfill, _reject) => {
            _request(_options, (_error, _response, _context) => {
                let errorResponse;
                if (_error) {
                    errorResponse = _baseController.validateResponse(_context);
                    _callback(errorResponse.error, errorResponse.response, errorResponse.context);
                    _reject(errorResponse.error);
                } else if (_response.statusCode >= 200 && _response.statusCode <= 206) {
                    let parsed = JSON.parse(_response.body);
                    parsed = _baseController.getObjectMapper().mapObject(parsed, 'LOSratesresponse');
                    _callback(null, parsed, _context);
                    _fulfill(parsed);
                } else {
                    errorResponse = _baseController.validateResponse(_context);
                    _callback(errorResponse.error, errorResponse.response, errorResponse.context);
                    _reject(errorResponse.error);
                }
            });
        });
    }
    /**
     * This function allows the logged in user to get a LOS rate for property.
     *
     * @param {string} productId Property ID in BookingPal
     *
     * @callback    The callback function that returns response from the API call
     *
     * @returns {Promise}
     */
    static getlospriceslistbyproductId(productId, callback) {
        // create empty callback if absent
        const _callback = typeof callback === 'function' ? callback : () => undefined;

        // prepare query string for API call
        const _baseUri = _configuration.BASEURI;

        let _pathUrl = '/losrates/{productId}';
        // process template parameters
        _pathUrl = _apiHelper.appendUrlWithTemplateParameters(_pathUrl, {
            productId: { value: productId, encode: true },
        });

        let _queryBuilder = `${_baseUri}${_pathUrl}`;

        // process query parameters
        _queryBuilder = _apiHelper.appendUrlWithQueryParameters(_queryBuilder, {
            jwt: _configuration.jwt,
        });

        // validate and preprocess url
        const _queryUrl = _apiHelper.cleanUrl(_queryBuilder);

        // prepare headers
        const _headers = {
            accept: 'application/json',
            'user-agent': 'APIMATIC 2.0',
        };

        // construct the request
        const _options = {
            queryUrl: _queryUrl,
            method: 'GET',
            headers: _headers,
        };

        // build the response processing.
        return new Promise((_fulfill, _reject) => {
            _request(_options, (_error, _response, _context) => {
                let errorResponse;
                if (_error) {
                    errorResponse = _baseController.validateResponse(_context);
                    _callback(errorResponse.error, errorResponse.response, errorResponse.context);
                    _reject(errorResponse.error);
                } else if (_response.statusCode >= 200 && _response.statusCode <= 206) {
                    let parsed = JSON.parse(_response.body);
                    parsed = _baseController.getObjectMapper().mapObject(parsed, 'LOSratesresponse');
                    _callback(null, parsed, _context);
                    _fulfill(parsed);
                } else {
                    errorResponse = _baseController.validateResponse(_context);
                    _callback(errorResponse.error, errorResponse.response, errorResponse.context);
                    _reject(errorResponse.error);
                }
            });
        });
    }
}
module.exports = LOSPricingController;
