/**
 * steve_tyler
 *
 * This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
 */

'use strict';

const _request = require('../Http/Client/RequestClient');
const _configuration = require('../configuration');
const _apiHelper = require('../APIHelper');
const _baseController = require('./BaseController');

class TestingOfMessageAPICallsController {
    /**
     * This function allows the logged in user to get all message threads or message threads with
     * an unresponded message from guest for the whole PM. You need to use PM credentials. There
     * is also paging as optional values. If you do not pass this value, we will return the first
     * page and 10 threads per page.
     * Since API calls for messages depend on channel connections and these values will exist in
     * BookingPal only if guests on channel create some message, these calls can work only on
     * production. So for testing purposes we’ve  built an additional endpoint with the same API
     * calls where you will be able to test these calls.
     * Note: To be able to test these calls, you need to have at least 1 property, since we will
     * in response return you messages for 1 property from your PM.
     *
     * @param {int} page TODO: type description here
     * @param {int} limit TODO: type description here
     * @param {string} threadType Request all threads or only threads with unanswered message {new,
     * all}
     *
     * @callback    The callback function that returns response from the API call
     *
     * @returns {Promise}
     */
    static getTestmessagethreads(page, limit, threadType, callback) {
        // create empty callback if absent
        const _callback = typeof callback === 'function' ? callback : () => undefined;

        // prepare query string for API call
        const _baseUri = _configuration.BASEURI;

        let _pathUrl = '/messageTest/allthreads/{threadType}';
        // process template parameters
        _pathUrl = _apiHelper.appendUrlWithTemplateParameters(_pathUrl, {
            threadType: { value: threadType, encode: true },
        });

        let _queryBuilder = `${_baseUri}${_pathUrl}`;

        // process query parameters
        _queryBuilder = _apiHelper.appendUrlWithQueryParameters(_queryBuilder, {
            page,
            limit,
            jwt: _configuration.jwt,
        });

        // validate and preprocess url
        const _queryUrl = _apiHelper.cleanUrl(_queryBuilder);

        // prepare headers
        const _headers = {
            accept: 'application/json',
            'user-agent': 'APIMATIC 2.0',
        };

        // construct the request
        const _options = {
            queryUrl: _queryUrl,
            method: 'GET',
            headers: _headers,
        };

        // build the response processing.
        return new Promise((_fulfill, _reject) => {
            _request(_options, (_error, _response, _context) => {
                let errorResponse;
                if (_error) {
                    errorResponse = _baseController.validateResponse(_context);
                    _callback(errorResponse.error, errorResponse.response, errorResponse.context);
                    _reject(errorResponse.error);
                } else if (_response.statusCode >= 200 && _response.statusCode <= 206) {
                    let parsed = JSON.parse(_response.body);
                    parsed = _baseController.getObjectMapper().mapObject(parsed, 'GetmessagethreadsResponse');
                    _callback(null, parsed, _context);
                    _fulfill(parsed);
                } else {
                    errorResponse = _baseController.validateResponse(_context);
                    _callback(errorResponse.error, errorResponse.response, errorResponse.context);
                    _reject(errorResponse.error);
                }
            });
        });
    }
    /**
     * Since API calls for messages depend on channel connections and these values will exist in
     * BookingPal only if guests on channel create some message, these calls can work only on
     * production. So for testing purposes, we’ve built an additional endpoint with the same API
     * calls where you will be able to test these calls.
     * This function allows the logged-in user to get a list of all messages from passed thread
     * Id. You need to use PM credentials
     * Note: To be able to test these calls, you need to have at least 1 property, since we will
     * in response return you messages for 1 property from your PM.
     *
     * @param {string} threadId ID of thread
     *
     * @callback    The callback function that returns response from the API call
     *
     * @returns {Promise}
     */
    static getTestmessagelistforspecificthread(threadId, callback) {
        // create empty callback if absent
        const _callback = typeof callback === 'function' ? callback : () => undefined;

        // prepare query string for API call
        const _baseUri = _configuration.BASEURI;

        let _pathUrl = '/messageTest/specificthread/{threadId}';
        // process template parameters
        _pathUrl = _apiHelper.appendUrlWithTemplateParameters(_pathUrl, {
            threadId: { value: threadId, encode: true },
        });

        let _queryBuilder = `${_baseUri}${_pathUrl}`;

        // process query parameters
        _queryBuilder = _apiHelper.appendUrlWithQueryParameters(_queryBuilder, {
            jwt: _configuration.jwt,
        });

        // validate and preprocess url
        const _queryUrl = _apiHelper.cleanUrl(_queryBuilder);

        // prepare headers
        const _headers = {
            accept: 'application/json',
            'user-agent': 'APIMATIC 2.0',
        };

        // construct the request
        const _options = {
            queryUrl: _queryUrl,
            method: 'GET',
            headers: _headers,
        };

        // build the response processing.
        return new Promise((_fulfill, _reject) => {
            _request(_options, (_error, _response, _context) => {
                let errorResponse;
                if (_error) {
                    errorResponse = _baseController.validateResponse(_context);
                    _callback(errorResponse.error, errorResponse.response, errorResponse.context);
                    _reject(errorResponse.error);
                } else if (_response.statusCode >= 200 && _response.statusCode <= 206) {
                    let parsed = JSON.parse(_response.body);
                    parsed = _baseController.getObjectMapper()
                .mapObject(parsed, 'GetmessagelistforspecificthreadResponse');
                    _callback(null, parsed, _context);
                    _fulfill(parsed);
                } else {
                    errorResponse = _baseController.validateResponse(_context);
                    _callback(errorResponse.error, errorResponse.response, errorResponse.context);
                    _reject(errorResponse.error);
                }
            });
        });
    }
    /**
     * This function will allow PM to post new messages in already existing threads. Since this
     * call is only for testing - we will not actually save these passed values.
     * Since API calls for messages depend on channel connections and these values will exist in
     * BookingPal only if guests on channel create some message, these calls can work only on
     * production. So for testing purposes, we’ve built an additional endpoint with the same API
     * calls where you will be able to test these calls.
     * Note: To be able to test these calls, you need to have at least 1 property, since we will
     * in response return to you messages for 1 property from your PM.
     *
     * @param {PostnewmessageforspecificthreadRequest} body TODO: type description here
     *
     * @callback    The callback function that returns response from the API call
     *
     * @returns {Promise}
     */
    static postnewTestmessageforspecificthread(body, callback) {
        // create empty callback if absent
        const _callback = typeof callback === 'function' ? callback : () => undefined;

        // prepare query string for API call
        const _baseUri = _configuration.BASEURI;

        const _pathUrl = '/messageTest';
        let _queryBuilder = `${_baseUri}${_pathUrl}`;

        // process query parameters
        _queryBuilder = _apiHelper.appendUrlWithQueryParameters(_queryBuilder, {
            jwt: _configuration.jwt,
        });

        // validate and preprocess url
        const _queryUrl = _apiHelper.cleanUrl(_queryBuilder);

        // prepare headers
        const _headers = {
            accept: 'application/json',
            'content-type': 'application/json; charset=utf-8',
            'user-agent': 'APIMATIC 2.0',
        };

        // construct the request
        const _options = {
            queryUrl: _queryUrl,
            method: 'POST',
            headers: _headers,
            body: _apiHelper.jsonSerialize(body),
        };

        // build the response processing.
        return new Promise((_fulfill, _reject) => {
            _request(_options, (_error, _response, _context) => {
                let errorResponse;
                if (_error) {
                    errorResponse = _baseController.validateResponse(_context);
                    _callback(errorResponse.error, errorResponse.response, errorResponse.context);
                    _reject(errorResponse.error);
                } else if (_response.statusCode >= 200 && _response.statusCode <= 206) {
                    let parsed = JSON.parse(_response.body);
                    parsed = _baseController.getObjectMapper().mapObject(parsed, 'APIResponsewithoutData');
                    _callback(null, parsed, _context);
                    _fulfill(parsed);
                } else {
                    errorResponse = _baseController.validateResponse(_context);
                    _callback(errorResponse.error, errorResponse.response, errorResponse.context);
                    _reject(errorResponse.error);
                }
            });
        });
    }
}
module.exports = TestingOfMessageAPICallsController;
