/**
 * steve_tyler
 *
 * This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
 */

'use strict';

const _request = require('../Http/Client/RequestClient');
const _configuration = require('../configuration');
const _apiHelper = require('../APIHelper');
const _baseController = require('./BaseController');

class ValidationController {
    /**
     * This function will allow the PMC to call the BookingPal property validation job for all
     * properties identified which belong to the current user. Authorization token should be on
     * PM level.
     * Also we will run validation only for properties which are activated. If you deactivate
     * property - we will not validate this property.
     * After the request you will get a response indicating if messages were processed or not. If
     * the request is good your request for the validator job will be put into a queue. Once the
     * request is processed, BookingPal will send an async push message per property informing
     * the user if a property is valid or not, and if it is not valid - with reasons why the
     * validation failed. This message will be sent on the endpoint which was entered in section
     * Push Notifications, field asyncPush.
     * Note: If the property is distributed already on some channel - this property will not be
     * moved to an Incomplete state. Also if you have property on Incomplete state because of
     * some reason, and you update this data which causes that property is on ‘Incomplete’
     * property will not be moved automatically to a valid state. Instead, you should run a
     * Validation job manually for that property or wait for our automatic validation job which
     * we are running once per day.
     * To make the property ready for Onboarding you should run validation first. if the property
     * is valid - it will be ready for onboarding. Otherwise - the property will be in Incomplete
     * state. Also, we will run validation only for properties that are activated. If you
     * deactivate property - we will not validate this property.
     *
     * @callback    The callback function that returns response from the API call
     *
     * @returns {Promise}
     */
    static bookingPalValidationjobFullPM(callback) {
        // create empty callback if absent
        const _callback = typeof callback === 'function' ? callback : () => undefined;

        // prepare query string for API call
        const _baseUri = _configuration.BASEURI;

        const _pathUrl = '/validation';
        let _queryBuilder = `${_baseUri}${_pathUrl}`;

        // process query parameters
        _queryBuilder = _apiHelper.appendUrlWithQueryParameters(_queryBuilder, {
            jwt: _configuration.jwt,
        });

        // validate and preprocess url
        const _queryUrl = _apiHelper.cleanUrl(_queryBuilder);

        // prepare headers
        const _headers = {
            accept: 'application/json',
            'user-agent': 'APIMATIC 2.0',
        };

        // construct the request
        const _options = {
            queryUrl: _queryUrl,
            method: 'GET',
            headers: _headers,
        };

        // build the response processing.
        return new Promise((_fulfill, _reject) => {
            _request(_options, (_error, _response, _context) => {
                let errorResponse;
                if (_error) {
                    errorResponse = _baseController.validateResponse(_context);
                    _callback(errorResponse.error, errorResponse.response, errorResponse.context);
                    _reject(errorResponse.error);
                } else if (_response.statusCode >= 200 && _response.statusCode <= 206) {
                    let parsed = JSON.parse(_response.body);
                    parsed = _baseController.getObjectMapper().mapObject(parsed, 'APIResponsewithoutData');
                    _callback(null, parsed, _context);
                    _fulfill(parsed);
                } else {
                    errorResponse = _baseController.validateResponse(_context);
                    _callback(errorResponse.error, errorResponse.response, errorResponse.context);
                    _reject(errorResponse.error);
                }
            });
        });
    }
    /**
     * This function will allow the PMS to call the BookingPal property validation job for a list
     * of properties from request. These properties must belong to the current user and
     * authorization token should be on PM level.
     * Also, we will run validation only for properties that are activated. If you deactivate
     * property - we will not validate this property.
     *
     * @param {string} contentType TODO: type description here
     * @param {ValidationforListofpropertiesRequest} body TODO: type description here
     *
     * @callback    The callback function that returns response from the API call
     *
     * @returns {Promise}
     */
    static bookingPalValidationjobListofproperties(contentType, body, callback) {
        // create empty callback if absent
        const _callback = typeof callback === 'function' ? callback : () => undefined;

        // prepare query string for API call
        const _baseUri = _configuration.BASEURI;

        const _pathUrl = '/validation';
        let _queryBuilder = `${_baseUri}${_pathUrl}`;

        // process query parameters
        _queryBuilder = _apiHelper.appendUrlWithQueryParameters(_queryBuilder, {
            jwt: _configuration.jwt,
        });

        // validate and preprocess url
        const _queryUrl = _apiHelper.cleanUrl(_queryBuilder);

        // prepare headers
        const _headers = {
            accept: 'application/json',
            'content-type': 'application/json; charset=utf-8',
            'Content-Type': contentType,
            'user-agent': 'APIMATIC 2.0',
        };

        // construct the request
        const _options = {
            queryUrl: _queryUrl,
            method: 'POST',
            headers: _headers,
            body: _apiHelper.jsonSerialize(body),
        };

        // build the response processing.
        return new Promise((_fulfill, _reject) => {
            _request(_options, (_error, _response, _context) => {
                let errorResponse;
                if (_error) {
                    errorResponse = _baseController.validateResponse(_context);
                    _callback(errorResponse.error, errorResponse.response, errorResponse.context);
                    _reject(errorResponse.error);
                } else if (_response.statusCode >= 200 && _response.statusCode <= 206) {
                    let parsed = JSON.parse(_response.body);
                    parsed = _baseController.getObjectMapper().mapObject(parsed, 'APIResponsewithoutData');
                    _callback(null, parsed, _context);
                    _fulfill(parsed);
                } else {
                    errorResponse = _baseController.validateResponse(_context);
                    _callback(errorResponse.error, errorResponse.response, errorResponse.context);
                    _reject(errorResponse.error);
                }
            });
        });
    }
}
module.exports = ValidationController;
