/**
 * steve_tyler
 *
 * This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
 */

'use strict';

const BaseModel = require('./BaseModel');

/**
 * Creates an instance of Property
 */
class Property extends BaseModel {
    /**
     * @constructor
     * @param   {Object}  obj    The object passed to constructor
     */
    constructor(obj) {
        super(obj);
        if (obj === undefined || obj === null) return;
        this.name = this.constructor.getValue(obj.name);
        this.id = this.constructor.getValue(obj.id);
        this.altId = this.constructor.getValue(obj.altId);
        this.supplierId = this.constructor.getValue(obj.supplierId);
        this.rooms = this.constructor.getValue(obj.rooms);
        this.bathrooms = this.constructor.getValue(obj.bathrooms);
        this.toilets = this.constructor.getValue(obj.toilets);
        this.totalBeds = this.constructor.getValue(obj.totalBeds);
        this.space = this.constructor.getValue(obj.space);
        this.spaceUnit = this.constructor.getValue(obj.spaceUnit);
        this.persons = this.constructor.getValue(obj.persons);
        this.childs = this.constructor.getValue(obj.childs);
        this.latitude = this.constructor.getValue(obj.latitude);
        this.longitude = this.constructor.getValue(obj.longitude);
        this.livingRoom = this.constructor.getValue(obj.livingRoom);
        this.notes = this.constructor.getValue(obj.notes);
        this.attributesWithQuantity = this.constructor.getValue(obj.attributesWithQuantity);
        this.nearbyAmenities = this.constructor.getValue(obj.nearbyAmenities);
        this.propertyType = this.constructor.getValue(obj.propertyType);
        this.bedroomConfiguration = this.constructor.getValue(obj.bedroomConfiguration);
        this.checkInTime = this.constructor.getValue(obj.checkInTime);
        this.checkInToTime = this.constructor.getValue(obj.checkInToTime);
        this.checkOutTime = this.constructor.getValue(obj.checkOutTime);
        this.currency = this.constructor.getValue(obj.currency);
        this.policy = this.constructor.getValue(obj.policy);
        this.location = this.constructor.getValue(obj.location);
        this.supportedLosRates = this.constructor.getValue(obj.supportedLosRates);
        this.taxNumber = this.constructor.getValue(obj.taxNumber);
        this.touristLicenseNumber = this.constructor.getValue(obj.touristLicenseNumber);
        this.touristLicenseExpiryDate = this.constructor.getValue(obj.touristLicenseExpiryDate);
        this.multiUnit = this.constructor.getValue(obj.multiUnit);
        this.parentId = this.constructor.getValue(obj.parentId);
    }

    /**
     * Function containing information about the fields of this model
     * @return   {array}   Array of objects containing information about the fields
     */
    static mappingInfo() {
        return super.mappingInfo().concat([
            { name: 'name', realName: 'name' },
            { name: 'id', realName: 'id' },
            { name: 'altId', realName: 'altId' },
            { name: 'supplierId', realName: 'supplierId' },
            { name: 'rooms', realName: 'rooms' },
            { name: 'bathrooms', realName: 'bathrooms' },
            { name: 'toilets', realName: 'toilets' },
            { name: 'totalBeds', realName: 'totalBeds' },
            { name: 'space', realName: 'space' },
            { name: 'spaceUnit', realName: 'spaceUnit' },
            { name: 'persons', realName: 'persons' },
            { name: 'childs', realName: 'childs' },
            { name: 'latitude', realName: 'latitude' },
            { name: 'longitude', realName: 'longitude' },
            { name: 'livingRoom', realName: 'livingRoom' },
            { name: 'notes', realName: 'notes', type: 'Notes' },
            {
                name: 'attributesWithQuantity',
                realName: 'attributesWithQuantity',
                array: true,
                type: 'AttributesWithQuantity',
            },
            {
                name: 'nearbyAmenities',
                realName: 'nearbyAmenities',
                array: true,
                type: 'NearbyAmenity',
            },
            { name: 'propertyType', realName: 'propertyType' },
            {
                name: 'bedroomConfiguration',
                realName: 'bedroomConfiguration',
                type: 'BedroomConfiguration',
            },
            { name: 'checkInTime', realName: 'checkInTime' },
            { name: 'checkInToTime', realName: 'checkInToTime' },
            { name: 'checkOutTime', realName: 'checkOutTime' },
            { name: 'currency', realName: 'currency' },
            { name: 'policy', realName: 'policy', type: 'Policy' },
            { name: 'location', realName: 'location', type: 'Location' },
            { name: 'supportedLosRates', realName: 'supportedLosRates' },
            { name: 'taxNumber', realName: 'taxNumber' },
            { name: 'touristLicenseNumber', realName: 'touristLicenseNumber' },
            {
                name: 'touristLicenseExpiryDate',
                realName: 'touristLicenseExpiryDate',
                isDateTime: true,
            },
            { name: 'multiUnit', realName: 'multiUnit' },
            { name: 'parentId', realName: 'parentId' },
        ]);
    }

    /**
     * Function containing information about discriminator values
     * mapped with their corresponding model class names
     *
     * @return   {object}  Object containing Key-Value pairs mapping discriminator
     *                     values with their corresponding model classes
     */
    static discriminatorMap() {
        return {};
    }
}

module.exports = Property;
